"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _lodash = _interopRequireDefault(require("lodash"));

var Utils = {
  /**
   *
   * @param {Object} config
   * @param {Object} config.data
   * @return {{finalCost: {allCostRemaining: number}}}
   */
  estimationCostFromTime: function () {
    var _estimationCostFromTime = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(config) {
      var mCostConfig, costBase, mSettings, finalCost;
      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              mCostConfig = _lodash["default"].merge({
                data: {},
                settings: {
                  minutes: {
                    cost: 2000,
                    costMax: 2000
                  },
                  hours: {
                    cost: 2000,
                    costMax: 10000
                  },
                  days: {
                    cost: 10000,
                    costMax: 100000
                  }
                }
              }, config);
              costBase = {};
              mSettings = mCostConfig.settings;
              Object.keys(mSettings).map( /*#__PURE__*/function () {
                var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(key) {
                  var mBaseKey, mTempContentBase;
                  return _regenerator["default"].wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          if (mCostConfig.data[key] !== undefined) {
                            mBaseKey = mCostConfig.data[key] * mSettings[key].cost;
                            mTempContentBase = {};
                            mTempContentBase.data = mCostConfig.data[key];
                            mTempContentBase.type = key;
                            mTempContentBase.summationCost = mBaseKey;
                            mTempContentBase.unitCost = mSettings[key].cost;
                            mTempContentBase.maxCost = mSettings[key].costMax;
                            mTempContentBase.costCategory = mSettings[key].costMax !== Infinity ? mBaseKey > mSettings[key].costMax ? "MAX" : "REMAINING" : "INFINITY";
                            mTempContentBase.estimationCost = mSettings[key].costMax !== Infinity ? mBaseKey > mSettings[key].costMax ? mSettings[key].costMax : mBaseKey : mBaseKey;
                            costBase[key] = mTempContentBase;
                          }

                        case 1:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee);
                }));

                return function (_x2) {
                  return _ref.apply(this, arguments);
                };
              }());
              finalCost = {
                allCostRemaining: 0
              };
              Object.keys(costBase).forEach( /*#__PURE__*/function () {
                var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(key, index) {
                  return _regenerator["default"].wrap(function _callee2$(_context2) {
                    while (1) {
                      switch (_context2.prev = _context2.next) {
                        case 0:
                          finalCost.allCostRemaining += costBase[key].estimationCost;

                        case 1:
                        case "end":
                          return _context2.stop();
                      }
                    }
                  }, _callee2);
                }));

                return function (_x3, _x4) {
                  return _ref2.apply(this, arguments);
                };
              }());
              return _context3.abrupt("return", _lodash["default"].merge(costBase, {
                finalCost: finalCost
              }));

            case 7:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    function estimationCostFromTime(_x) {
      return _estimationCostFromTime.apply(this, arguments);
    }

    return estimationCostFromTime;
  }()
};
var _default = Utils;
exports["default"] = _default;
//# sourceMappingURL=index.js.map