"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _lodash = _interopRequireDefault(require("lodash"));

var _Options = _interopRequireDefault(require("./../../Options"));

var _Security = _interopRequireDefault(require("../../Security"));

function checkModuleExist(name) {
  try {
    require.resolve(name);

    return true;
  } catch (e) {
    return false;
  }
}

var Reader = null;
var mNFC = null;

var Nfc = /*#__PURE__*/function () {
  /**
   *
   * @returns {Nfc}
   */
  function Nfc(_config) {
    var _this = this;

    (0, _classCallCheck2["default"])(this, Nfc);
    (0, _defineProperty2["default"])(this, "mNFC", null);
    (0, _defineProperty2["default"])(this, "mUSBDetection", null);
    (0, _defineProperty2["default"])(this, "eventEmit", null);
    (0, _defineProperty2["default"])(this, "Initilization", function () {
      if (checkModuleExist("nfc-pcsc")) {
        var _require = require("nfc-pcsc"),
            NFC = _require.NFC;

        try {
          mNFC = new NFC();
          mNFC.on('reader', /*#__PURE__*/function () {
            var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(reader) {
              return _regenerator["default"].wrap(function _callee5$(_context5) {
                while (1) {
                  switch (_context5.prev = _context5.next) {
                    case 0:
                      _this.mEventEmitter.emit("reader", reader);

                      _this.config.state === _Options["default"].SERVER_STATE_DEVELOPMENT ? console.log("DKA NFC EVENT :: Reader ready ! :", "".concat(reader)) : false;
                      reader.autoProcessing = _this.config.options.autoProcessing;
                      _context5.next = 5;
                      return reader.on('card', /*#__PURE__*/function () {
                        var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(card) {
                          return _regenerator["default"].wrap(function _callee$(_context) {
                            while (1) {
                              switch (_context.prev = _context.next) {
                                case 0:
                                  _this.mEventEmitter.emit("card", {
                                    reader: reader,
                                    card: card
                                  });

                                  _this.config.state === _Options["default"].SERVER_STATE_DEVELOPMENT ? console.log("DKA NFC EVENT :: Card Detected :", "".concat(card)) : false;

                                case 2:
                                case "end":
                                  return _context.stop();
                              }
                            }
                          }, _callee);
                        }));

                        return function (_x2) {
                          return _ref2.apply(this, arguments);
                        };
                      }());

                    case 5:
                      reader.on('card.off', /*#__PURE__*/function () {
                        var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(card) {
                          return _regenerator["default"].wrap(function _callee2$(_context2) {
                            while (1) {
                              switch (_context2.prev = _context2.next) {
                                case 0:
                                  _this.mEventEmitter.emit("card.off", card);

                                  _this.config.state === _Options["default"].SERVER_STATE_DEVELOPMENT ? console.log("DKA NFC EVENT :: Card Remove :", "".concat(card)) : false;

                                case 2:
                                case "end":
                                  return _context2.stop();
                              }
                            }
                          }, _callee2);
                        }));

                        return function (_x3) {
                          return _ref3.apply(this, arguments);
                        };
                      }());
                      _context5.next = 8;
                      return reader.on('error', /*#__PURE__*/function () {
                        var _ref4 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(error) {
                          return _regenerator["default"].wrap(function _callee3$(_context3) {
                            while (1) {
                              switch (_context3.prev = _context3.next) {
                                case 0:
                                  _this.mEventEmitter.emit("card.error", {
                                    status: false,
                                    code: 502,
                                    msg: "Reader Error",
                                    error: error
                                  });

                                  _this.config.state === _Options["default"].SERVER_STATE_DEVELOPMENT ? console.log("DKA NFC EVENT :: Reader Error :", "".concat(error)) : false;

                                case 2:
                                case "end":
                                  return _context3.stop();
                              }
                            }
                          }, _callee3);
                        }));

                        return function (_x4) {
                          return _ref4.apply(this, arguments);
                        };
                      }());

                    case 8:
                      _context5.next = 10;
                      return reader.on('end', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4() {
                        return _regenerator["default"].wrap(function _callee4$(_context4) {
                          while (1) {
                            switch (_context4.prev = _context4.next) {
                              case 0:
                                _this.mEventEmitter.emit('card.end');

                                _this.config.state === _Options["default"].SERVER_STATE_DEVELOPMENT ? console.log("DKA NFC EVENT :: Card End") : false;

                              case 2:
                              case "end":
                                return _context4.stop();
                            }
                          }
                        }, _callee4);
                      })));

                    case 10:
                    case "end":
                      return _context5.stop();
                  }
                }
              }, _callee5);
            }));

            return function (_x) {
              return _ref.apply(this, arguments);
            };
          }());
          mNFC.on('error', /*#__PURE__*/function () {
            var _ref6 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6(err) {
              var nFCErrorExtractStatus, error;
              return _regenerator["default"].wrap(function _callee6$(_context6) {
                while (1) {
                  switch (_context6.prev = _context6.next) {
                    case 0:
                      nFCErrorExtractStatus = {
                        code: err.toString().split(":")[1].toString(),
                        description: err.toString().split(":")[2].toString()
                      };
                      error = {
                        status: false,
                        code: 500,
                        msg: "NFC Error",
                        error: nFCErrorExtractStatus
                      };

                      _this.mEventEmitter.emit("nfc.error", error);

                      _this.config.state === _Options["default"].SERVER_STATE_DEVELOPMENT ? console.log("nfc error : ", "".concat(nFCErrorExtractStatus)) : false;

                    case 4:
                    case "end":
                      return _context6.stop();
                  }
                }
              }, _callee6);
            }));

            return function (_x5) {
              return _ref6.apply(this, arguments);
            };
          }());
        } catch (e) {
          var error = {
            status: false,
            code: 505,
            msg: "Unknown Error",
            error: e
          };

          _this.mEventEmitter.emit("nfc.fatal", error);
        }
      } else {
        throw Error("MODULE `nfc-pcsc` not Installed. Please Installed First");
      }
    });
    (0, _defineProperty2["default"])(this, "Trigger", /*#__PURE__*/function () {
      var _ref7 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee14(callback) {
        return _regenerator["default"].wrap(function _callee14$(_context14) {
          while (1) {
            switch (_context14.prev = _context14.next) {
              case 0:
                _context14.next = 2;
                return _this.mEventEmitter.on("reader", /*#__PURE__*/function () {
                  var _ref8 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7(reader) {
                    return _regenerator["default"].wrap(function _callee7$(_context7) {
                      while (1) {
                        switch (_context7.prev = _context7.next) {
                          case 0:
                            _context7.next = 2;
                            return callback({
                              event: "READER",
                              response: reader
                            });

                          case 2:
                          case "end":
                            return _context7.stop();
                        }
                      }
                    }, _callee7);
                  }));

                  return function (_x7) {
                    return _ref8.apply(this, arguments);
                  };
                }());

              case 2:
                _context14.next = 4;
                return _this.mEventEmitter.on("card.error", /*#__PURE__*/function () {
                  var _ref9 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee8(reader) {
                    return _regenerator["default"].wrap(function _callee8$(_context8) {
                      while (1) {
                        switch (_context8.prev = _context8.next) {
                          case 0:
                            _context8.next = 2;
                            return callback({
                              event: "READER_ERROR",
                              response: reader
                            });

                          case 2:
                          case "end":
                            return _context8.stop();
                        }
                      }
                    }, _callee8);
                  }));

                  return function (_x8) {
                    return _ref9.apply(this, arguments);
                  };
                }());

              case 4:
                _context14.next = 6;
                return _this.mEventEmitter.on("card", /*#__PURE__*/function () {
                  var _ref10 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee9(card) {
                    return _regenerator["default"].wrap(function _callee9$(_context9) {
                      while (1) {
                        switch (_context9.prev = _context9.next) {
                          case 0:
                            _context9.next = 2;
                            return callback({
                              event: "CARD_DETECTED",
                              response: card
                            });

                          case 2:
                          case "end":
                            return _context9.stop();
                        }
                      }
                    }, _callee9);
                  }));

                  return function (_x9) {
                    return _ref10.apply(this, arguments);
                  };
                }());

              case 6:
                _context14.next = 8;
                return _this.mEventEmitter.on("card.off", /*#__PURE__*/function () {
                  var _ref11 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee10(card) {
                    return _regenerator["default"].wrap(function _callee10$(_context10) {
                      while (1) {
                        switch (_context10.prev = _context10.next) {
                          case 0:
                            _context10.next = 2;
                            return callback({
                              event: "CARD_OFF",
                              response: card
                            });

                          case 2:
                          case "end":
                            return _context10.stop();
                        }
                      }
                    }, _callee10);
                  }));

                  return function (_x10) {
                    return _ref11.apply(this, arguments);
                  };
                }());

              case 8:
                _context14.next = 10;
                return _this.mEventEmitter.on("nfc.error", /*#__PURE__*/function () {
                  var _ref12 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee11(error) {
                    return _regenerator["default"].wrap(function _callee11$(_context11) {
                      while (1) {
                        switch (_context11.prev = _context11.next) {
                          case 0:
                            _context11.next = 2;
                            return callback({
                              event: "NFC_ERROR",
                              response: error
                            });

                          case 2:
                          case "end":
                            return _context11.stop();
                        }
                      }
                    }, _callee11);
                  }));

                  return function (_x11) {
                    return _ref12.apply(this, arguments);
                  };
                }());

              case 10:
                _context14.next = 12;
                return _this.mEventEmitter.on("nfc.fatal", /*#__PURE__*/function () {
                  var _ref13 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee12(error) {
                    return _regenerator["default"].wrap(function _callee12$(_context12) {
                      while (1) {
                        switch (_context12.prev = _context12.next) {
                          case 0:
                            _context12.next = 2;
                            return callback({
                              event: "FATAL_ERROR",
                              response: error
                            });

                          case 2:
                          case "end":
                            return _context12.stop();
                        }
                      }
                    }, _callee12);
                  }));

                  return function (_x12) {
                    return _ref13.apply(this, arguments);
                  };
                }());

              case 12:
                _context14.next = 14;
                return _this.mEventEmitter.on("nfc.unknown.error", /*#__PURE__*/function () {
                  var _ref14 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee13(error) {
                    return _regenerator["default"].wrap(function _callee13$(_context13) {
                      while (1) {
                        switch (_context13.prev = _context13.next) {
                          case 0:
                            _context13.next = 2;
                            return callback({
                              event: "UNKNOWN_ERROR",
                              response: error
                            });

                          case 2:
                          case "end":
                            return _context13.stop();
                        }
                      }
                    }, _callee13);
                  }));

                  return function (_x13) {
                    return _ref14.apply(this, arguments);
                  };
                }());

              case 14:
                return _context14.abrupt("return", _this);

              case 15:
              case "end":
                return _context14.stop();
            }
          }
        }, _callee14);
      }));

      return function (_x6) {
        return _ref7.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "LoadAuthentificationKey", /*#__PURE__*/function () {
      var _ref15 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee18(keyNumber, key, response) {
        return _regenerator["default"].wrap(function _callee18$(_context18) {
          while (1) {
            switch (_context18.prev = _context18.next) {
              case 0:
                _context18.next = 2;
                return _this.mEventEmitter.on("card", /*#__PURE__*/function () {
                  var _ref16 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee17(result) {
                    var reader;
                    return _regenerator["default"].wrap(function _callee17$(_context17) {
                      while (1) {
                        switch (_context17.prev = _context17.next) {
                          case 0:
                            reader = result.reader;
                            _context17.next = 3;
                            return reader.loadAuthenticationKey(keyNumber, key).then( /*#__PURE__*/function () {
                              var _ref17 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee15(res) {
                                return _regenerator["default"].wrap(function _callee15$(_context15) {
                                  while (1) {
                                    switch (_context15.prev = _context15.next) {
                                      case 0:
                                        _context15.next = 2;
                                        return response({
                                          status: true,
                                          code: 200,
                                          msg: "Successfully Load Authentification Key "
                                        });

                                      case 2:
                                      case "end":
                                        return _context15.stop();
                                    }
                                  }
                                }, _callee15);
                              }));

                              return function (_x18) {
                                return _ref17.apply(this, arguments);
                              };
                            }())["catch"]( /*#__PURE__*/function () {
                              var _ref18 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee16(error) {
                                return _regenerator["default"].wrap(function _callee16$(_context16) {
                                  while (1) {
                                    switch (_context16.prev = _context16.next) {
                                      case 0:
                                        _context16.next = 2;
                                        return response({
                                          status: false,
                                          code: 500,
                                          msg: "Failed Load Authentification Key ",
                                          error: error
                                        });

                                      case 2:
                                      case "end":
                                        return _context16.stop();
                                    }
                                  }
                                }, _callee16);
                              }));

                              return function (_x19) {
                                return _ref18.apply(this, arguments);
                              };
                            }());

                          case 3:
                          case "end":
                            return _context17.stop();
                        }
                      }
                    }, _callee17);
                  }));

                  return function (_x17) {
                    return _ref16.apply(this, arguments);
                  };
                }());

              case 2:
              case "end":
                return _context18.stop();
            }
          }
        }, _callee18);
      }));

      return function (_x14, _x15, _x16) {
        return _ref15.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "Authentificate", /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee20() {
      var arraySectorCluster,
          response,
          _args20 = arguments;
      return _regenerator["default"].wrap(function _callee20$(_context20) {
        while (1) {
          switch (_context20.prev = _context20.next) {
            case 0:
              arraySectorCluster = _args20.length > 0 && _args20[0] !== undefined ? _args20[0] : [];
              response = _args20.length > 1 ? _args20[1] : undefined;
              _context20.next = 4;
              return _this.mEventEmitter.on("card", /*#__PURE__*/function () {
                var _ref20 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee19(result) {
                  var reader, mArrayPass, num;
                  return _regenerator["default"].wrap(function _callee19$(_context19) {
                    while (1) {
                      switch (_context19.prev = _context19.next) {
                        case 0:
                          reader = result.reader;
                          mArrayPass = [];
                          num = 0;
                          _context19.next = 5;
                          return arraySectorCluster.forEach(function () {
                            try {
                              reader.authenticate(arraySectorCluster[num].blockNumber, arraySectorCluster[num].keyType, arraySectorCluster[num].key);
                              mArrayPass.push({
                                status: true,
                                blockNumber: arraySectorCluster[num].blockNumber
                              });
                            } catch (e) {
                              mArrayPass.push({
                                status: false,
                                blockNumber: arraySectorCluster[num].blockNumber
                              });
                            }

                            num++;
                          });

                        case 5:
                          _context19.next = 7;
                          return response(mArrayPass);

                        case 7:
                        case "end":
                          return _context19.stop();
                      }
                    }
                  }, _callee19);
                }));

                return function (_x20) {
                  return _ref20.apply(this, arguments);
                };
              }());

            case 4:
              return _context20.abrupt("return", _this);

            case 5:
            case "end":
              return _context20.stop();
          }
        }
      }, _callee20);
    })));
    (0, _defineProperty2["default"])(this, "Read", /*#__PURE__*/function () {
      var _ref21 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee23(blockNumber, response) {
        return _regenerator["default"].wrap(function _callee23$(_context23) {
          while (1) {
            switch (_context23.prev = _context23.next) {
              case 0:
                _this.configRead = {};
                _context23.t0 = (0, _typeof2["default"])(blockNumber);
                _context23.next = _context23.t0 === "number" ? 4 : _context23.t0 === "object" ? 8 : 12;
                break;

              case 4:
                _context23.next = 6;
                return _lodash["default"].merge({
                  blockNumber: blockNumber,
                  dataLength: 16,
                  blockSize: 16,
                  authenticate: {
                    keyType: _this.config.authenticate.typeKey,
                    key: _this.config.authenticate.key
                  }
                });

              case 6:
                _this.configRead = _context23.sent;
                return _context23.abrupt("break", 12);

              case 8:
                _context23.next = 10;
                return _lodash["default"].merge({
                  blockNumber: 4,
                  dataLength: 16,
                  blockSize: 16,
                  authenticate: {
                    keyType: _this.config.authenticate.typeKey,
                    key: _this.config.authenticate.key
                  }
                }, blockNumber);

              case 10:
                _this.configRead = _context23.sent;
                return _context23.abrupt("break", 12);

              case 12:
                _context23.next = 14;
                return _this.mEventEmitter.on("card", /*#__PURE__*/function () {
                  var _ref22 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee22(result) {
                    var reader, mRead, tempRawData, arrayTypeData, objectTempData, mResponseTemp;
                    return _regenerator["default"].wrap(function _callee22$(_context22) {
                      while (1) {
                        switch (_context22.prev = _context22.next) {
                          case 0:
                            reader = result.reader;
                            _context22.prev = 1;
                            _context22.next = 4;
                            return reader.authenticate(_this.configRead.blockNumber, _this.configRead.authenticate.keyType, _this.configRead.authenticate.key);

                          case 4:
                            _context22.next = 6;
                            return reader.read(_this.configRead.blockNumber, _this.configRead.length, _this.configRead.blockSize);

                          case 6:
                            mRead = _context22.sent;

                            if (!_this.config.options.encryption.enabled) {
                              _context22.next = 11;
                              break;
                            }

                            _context22.next = 10;
                            return new _Security["default"].Encryption.Crypto({
                              algorithm: _Options["default"].ALGORITHM_AES_128_GCM
                            }).decodeIvSync(mRead);

                          case 10:
                            mRead = _context22.sent;

                          case 11:
                            tempRawData = mRead.toString().split("@")[0];
                            arrayTypeData = tempRawData.split("#");
                            objectTempData = {};
                            arrayTypeData.map( /*#__PURE__*/function () {
                              var _ref23 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee21(values) {
                                var jsonData;
                                return _regenerator["default"].wrap(function _callee21$(_context21) {
                                  while (1) {
                                    switch (_context21.prev = _context21.next) {
                                      case 0:
                                        jsonData = values.split(":");
                                        objectTempData[jsonData[0]] = jsonData[1]; // jsonData.map(async (mValues) => {
                                        //     console.log(mValues)
                                        //     objectTempData[mValues[0]] = mValues[1]
                                        // })

                                      case 2:
                                      case "end":
                                        return _context21.stop();
                                    }
                                  }
                                }, _callee21);
                              }));

                              return function (_x24) {
                                return _ref23.apply(this, arguments);
                              };
                            }());
                            mResponseTemp = {
                              status: true,
                              code: 200,
                              msg: "Successfully Read Data",
                              data: {
                                raw: mRead,
                                string: mRead.toString().split("@")[0],
                                length: mRead.toString().length,
                                refactorData: {
                                  companyId: mRead.toString().split("@")[0].split("#")[0],
                                  type_card: mRead.toString().split("@")[0].split("#")[1],
                                  uid_identify: mRead.toString().split("@")[0].split("#")[2]
                                },
                                card: {
                                  atr: result.card.atr,
                                  standard: result.card.standard,
                                  type: result.card.type,
                                  uid: result.card.uid
                                }
                              }
                            };
                            mResponseTemp.data.refactorData = objectTempData;
                            _context22.next = 19;
                            return response(mResponseTemp);

                          case 19:
                            _context22.next = 25;
                            break;

                          case 21:
                            _context22.prev = 21;
                            _context22.t0 = _context22["catch"](1);
                            _context22.next = 25;
                            return response({
                              status: false,
                              code: 500,
                              msg: "Failed Read Data",
                              error: _context22.t0
                            });

                          case 25:
                          case "end":
                            return _context22.stop();
                        }
                      }
                    }, _callee22, null, [[1, 21]]);
                  }));

                  return function (_x23) {
                    return _ref22.apply(this, arguments);
                  };
                }());

              case 14:
                return _context23.abrupt("return", _this);

              case 15:
              case "end":
                return _context23.stop();
            }
          }
        }, _callee23);
      }));

      return function (_x21, _x22) {
        return _ref21.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "Baca", this.Read);
    (0, _defineProperty2["default"])(this, "Write", /*#__PURE__*/function () {
      var _ref24 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee26(data, response) {
        var mFinalDataToString;
        return _regenerator["default"].wrap(function _callee26$(_context26) {
          while (1) {
            switch (_context26.prev = _context26.next) {
              case 0:
                _this.configWrite = {};
                mFinalDataToString = "";
                _context26.t0 = (0, _typeof2["default"])(data);
                _context26.next = _context26.t0 === "string" ? 5 : _context26.t0 === "object" ? 9 : 21;
                break;

              case 5:
                _context26.next = 7;
                return _lodash["default"].merge({
                  blockNumber: 4,
                  data: data,
                  dataLength: 16,
                  blockSize: 16,
                  authenticate: {
                    keyType: _this.config.authenticate.typeKey,
                    key: _this.config.authenticate.key
                  }
                });

              case 7:
                _this.configWrite = _context26.sent;
                return _context26.abrupt("break", 21);

              case 9:
                _context26.next = 11;
                return _lodash["default"].merge({
                  blockNumber: 4,
                  data: data.data,
                  dataLength: 16,
                  blockSize: 16,
                  authenticate: {
                    keyType: _this.config.authenticate.typeKey,
                    key: _this.config.authenticate.key
                  }
                }, data);

              case 11:
                _this.configWrite = _context26.sent;
                _context26.t1 = (0, _typeof2["default"])(_this.configWrite.data);
                _context26.next = _context26.t1 === "object" ? 15 : _context26.t1 === "string" ? 18 : 20;
                break;

              case 15:
                //console.log(this.configWrite.data)

                /** Add Separator Split Character (#) for The push Data **/
                Object.keys(_this.configWrite.data).map( /*#__PURE__*/function () {
                  var _ref25 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee24(key, index, array) {
                    return _regenerator["default"].wrap(function _callee24$(_context24) {
                      while (1) {
                        switch (_context24.prev = _context24.next) {
                          case 0:
                            if (index !== array.length - 1) {
                              mFinalDataToString += "".concat(key, ":").concat(_this.configWrite.data[key], "#");
                            } else {
                              mFinalDataToString += "".concat(key, ":").concat(_this.configWrite.data[key]);
                            }

                          case 1:
                          case "end":
                            return _context24.stop();
                        }
                      }
                    }, _callee24);
                  }));

                  return function (_x27, _x28, _x29) {
                    return _ref25.apply(this, arguments);
                  };
                }());
                _this.configWrite.data = mFinalDataToString;
                return _context26.abrupt("break", 20);

              case 18:
                _this.configWrite.data = data.data;
                return _context26.abrupt("break", 20);

              case 20:
                return _context26.abrupt("break", 21);

              case 21:
                _context26.next = 23;
                return _this.mEventEmitter.on("card", /*#__PURE__*/function () {
                  var _ref26 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee25(result) {
                    var reader, mBuffer, mFillData;
                    return _regenerator["default"].wrap(function _callee25$(_context25) {
                      while (1) {
                        switch (_context25.prev = _context25.next) {
                          case 0:
                            reader = result.reader;
                            _context25.prev = 1;
                            _context25.next = 4;
                            return reader.authenticate(_this.configWrite.blockNumber, _this.configWrite.authenticate.keyType, _this.configWrite.authenticate.key);

                          case 4:
                            _context25.next = 6;
                            return Buffer.allocUnsafe(_this.configWrite.dataLength);

                          case 6:
                            mBuffer = _context25.sent;
                            mFillData = "".concat(_this.configWrite.data, "@");

                            if (_this.config.options.encryption.enabled) {
                              mFillData = new _Security["default"].Encryption.Crypto({
                                algorithm: _Options["default"].ALGORITHM_AES_128_GCM
                              }).encodeIvSync(mFillData);
                            }

                            _context25.next = 11;
                            return mBuffer.fill(mFillData);

                          case 11:
                            if (!(_this.configWrite.data.length <= _this.configWrite.dataLength)) {
                              _context25.next = 26;
                              break;
                            }

                            _context25.t0 = _this.config.cardType;
                            _context25.next = _context25.t0 === _Options["default"].MIFARE_CLASSIC_1K ? 15 : 24;
                            break;

                          case 15:
                            if (!(_this.configWrite.blockNumber === 4 || _this.configWrite.blockNumber === 8)) {
                              _context25.next = 22;
                              break;
                            }

                            _context25.next = 18;
                            return reader.write(_this.configWrite.blockNumber, mBuffer, _this.configWrite.blockSize);

                          case 18:
                            _context25.next = 20;
                            return response({
                              status: true,
                              code: 200,
                              msg: "Successfully Write Data",
                              data: {
                                raw: mBuffer.toString()
                              }
                            });

                          case 20:
                            _context25.next = 24;
                            break;

                          case 22:
                            _context25.next = 24;
                            return response({
                              status: false,
                              code: 505,
                              msg: "Failed Write Data. for Mifare 1 K blockNumber must 4 or 8 "
                            });

                          case 24:
                            _context25.next = 28;
                            break;

                          case 26:
                            _context25.next = 28;
                            return response({
                              status: false,
                              code: 505,
                              msg: "Failed Write Data. the data length must smaller than options 'dataLength' "
                            });

                          case 28:
                            _context25.next = 34;
                            break;

                          case 30:
                            _context25.prev = 30;
                            _context25.t1 = _context25["catch"](1);
                            _context25.next = 34;
                            return response({
                              status: false,
                              code: 500,
                              msg: "AUTHENTIFICATION : error",
                              error: _context25.t1
                            });

                          case 34:
                          case "end":
                            return _context25.stop();
                        }
                      }
                    }, _callee25, null, [[1, 30]]);
                  }));

                  return function (_x30) {
                    return _ref26.apply(this, arguments);
                  };
                }());

              case 23:
                return _context26.abrupt("return", _this);

              case 24:
              case "end":
                return _context26.stop();
            }
          }
        }, _callee26);
      }));

      return function (_x25, _x26) {
        return _ref24.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "Tulis", this.Write);
    (0, _defineProperty2["default"])(this, "Reset", /*#__PURE__*/function () {
      var _ref27 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee28(config, response) {
        var WriteConfig;
        return _regenerator["default"].wrap(function _callee28$(_context28) {
          while (1) {
            switch (_context28.prev = _context28.next) {
              case 0:
                _context28.next = 2;
                return _lodash["default"].merge({
                  blockNumber: 4,
                  blockSize: 16,
                  authentification: {
                    typeKey: _this.KEY_TYPE_A,
                    key: "FFFFFFFFFFFF"
                  }
                }, config);

              case 2:
                WriteConfig = _context28.sent;

                _this.mEventEmitter.on("card", /*#__PURE__*/function () {
                  var _ref28 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee27(result) {
                    var reader, mBuffer;
                    return _regenerator["default"].wrap(function _callee27$(_context27) {
                      while (1) {
                        switch (_context27.prev = _context27.next) {
                          case 0:
                            reader = result.reader;
                            _context27.prev = 1;
                            _context27.next = 4;
                            return reader.authenticate(WriteConfig.blockNumber, WriteConfig.authentification.typeKey, WriteConfig.authentification.key);

                          case 4:
                            _context27.next = 6;
                            return Buffer.allocUnsafe(WriteConfig.blockSize);

                          case 6:
                            mBuffer = _context27.sent;
                            _context27.next = 9;
                            return mBuffer.fill(0);

                          case 9:
                            _context27.next = 11;
                            return reader.write(WriteConfig.blockNumber, mBuffer, WriteConfig.blockSize);

                          case 11:
                            _context27.next = 13;
                            return response({
                              status: true,
                              code: 200,
                              msg: "Successfully Reset Data",
                              data: mBuffer.toString()
                            });

                          case 13:
                            _context27.next = 19;
                            break;

                          case 15:
                            _context27.prev = 15;
                            _context27.t0 = _context27["catch"](1);
                            _context27.next = 19;
                            return response({
                              status: false,
                              code: 505,
                              msg: "AUTHENTIFICATION : error",
                              error: _context27.t0
                            });

                          case 19:
                          case "end":
                            return _context27.stop();
                        }
                      }
                    }, _callee27, null, [[1, 15]]);
                  }));

                  return function (_x33) {
                    return _ref28.apply(this, arguments);
                  };
                }());

                return _context28.abrupt("return", _this);

              case 5:
              case "end":
                return _context28.stop();
            }
          }
        }, _callee28);
      }));

      return function (_x31, _x32) {
        return _ref27.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "Format", this.Reset);
    this.config = _lodash["default"].merge({
      state: _Options["default"].SERVER_STATE_DEVELOPMENT,
      findBy: {
        hardwareIds: false,
        hardwareName: "ACR122"
      },
      cardType: _Options["default"].MIFARE_CLASSIC_1K,
      authenticate: {
        typeKey: Nfc.KEY_TYPE_A,
        key: "FFFFFFFFFFFF"
      },
      options: {
        autoProcessing: true,
        encryption: {
          enabled: false
        }
      }
    }, _config);

    var EventEmitter = require("node:events");

    this.mEventEmitter = new EventEmitter();

    if (checkModuleExist("usb-detection")) {
      var mUSBDetect = this.mUSBDetection = require("usb-detection");

      mUSBDetect.on("remove", /*#__PURE__*/function () {
        var _ref29 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee29(device) {
          return _regenerator["default"].wrap(function _callee29$(_context29) {
            while (1) {
              switch (_context29.prev = _context29.next) {
                case 0:
                  _context29.prev = 0;
                  _context29.next = 3;
                  return _this.mEventEmitter.removeAllListeners("nfc.error");

                case 3:
                  _context29.next = 5;
                  return mNFC.close();

                case 5:
                  _context29.next = 7;
                  return _this.mEventEmitter.removeAllListeners();

                case 7:
                  _context29.next = 11;
                  break;

                case 9:
                  _context29.prev = 9;
                  _context29.t0 = _context29["catch"](0);

                case 11:
                  //##############################################################
                  _this.config.state === _Options["default"].SERVER_STATE_DEVELOPMENT ? console.log("Detecting NFC Devices Unplugged USB remove ", "clear Instance") : null; //###############################################################

                case 12:
                case "end":
                  return _context29.stop();
              }
            }
          }, _callee29, null, [[0, 9]]);
        }));

        return function (_x34) {
          return _ref29.apply(this, arguments);
        };
      }());
      mUSBDetect.on('add', /*#__PURE__*/function () {
        var _ref30 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee30(device) {
          return _regenerator["default"].wrap(function _callee30$(_context30) {
            while (1) {
              switch (_context30.prev = _context30.next) {
                case 0:
                  //##############################################################
                  _this.config.state === _Options["default"].SERVER_STATE_DEVELOPMENT ? console.log("Detecting NFC Devices Plugged USB Add ", "Reinitialization Instance") : null; //###############################################################

                  _context30.next = 3;
                  return _this.Initilization();

                case 3:
                case "end":
                  return _context30.stop();
              }
            }
          }, _callee30);
        }));

        return function (_x35) {
          return _ref30.apply(this, arguments);
        };
      }());

      if (this.config.findBy.hardwareIds) {
        mUSBDetect.find(this.config.findBy.hardwareIds.vendorId, this.config.findBy.hardwareIds.productId, /*#__PURE__*/function () {
          var _ref31 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee31(error, device) {
            return _regenerator["default"].wrap(function _callee31$(_context31) {
              while (1) {
                switch (_context31.prev = _context31.next) {
                  case 0:
                    if (error) {
                      _context31.next = 13;
                      break;
                    }

                    if (!(device.length > 0)) {
                      _context31.next = 6;
                      break;
                    }

                    //##############################################################
                    _this.config.state === _Options["default"].SERVER_STATE_DEVELOPMENT ? console.log("FIND NFC Devices Plugged ", "".concat(JSON.stringify(device))) : null; //###############################################################

                    _this.Initilization();

                    _context31.next = 11;
                    break;

                  case 6:
                    //##############################################################
                    _this.config.state === _Options["default"].SERVER_STATE_DEVELOPMENT ? console.log("Start Monitoring NFC Devices ", "".concat(JSON.stringify(device))) : null; //###############################################################

                    _context31.next = 9;
                    return mUSBDetect.stopMonitoring();

                  case 9:
                    _context31.next = 11;
                    return mUSBDetect.startMonitoring();

                  case 11:
                    _context31.next = 18;
                    break;

                  case 13:
                    //##############################################################
                    _this.config.state === _Options["default"].SERVER_STATE_DEVELOPMENT ? console.log("Start Monitoring NFC Devices ", "".concat(JSON.stringify(device))) : null; //###############################################################

                    _context31.next = 16;
                    return mUSBDetect.stopMonitoring();

                  case 16:
                    _context31.next = 18;
                    return mUSBDetect.startMonitoring();

                  case 18:
                  case "end":
                    return _context31.stop();
                }
              }
            }, _callee31);
          }));

          return function (_x36, _x37) {
            return _ref31.apply(this, arguments);
          };
        }());
      } else {
        mUSBDetect.find().then( /*#__PURE__*/function () {
          var _ref32 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee32(device) {
            var findState, mHardwareNames;
            return _regenerator["default"].wrap(function _callee32$(_context32) {
              while (1) {
                switch (_context32.prev = _context32.next) {
                  case 0:
                    findState = false;
                    mHardwareNames = _this.config.findBy.hardwareName;
                    _context32.next = 4;
                    return device.forEach(function (object) {
                      if (object.deviceName.match(mHardwareNames)) {
                        findState = device;
                      }
                    });

                  case 4:
                    if (!(findState !== false)) {
                      _context32.next = 9;
                      break;
                    }

                    //##############################################################
                    _this.config.state === _Options["default"].SERVER_STATE_DEVELOPMENT ? console.log("FIND NFC Devices Plugged By Hardware Name") : null; //###############################################################

                    _this.Initilization();

                    _context32.next = 14;
                    break;

                  case 9:
                    //##############################################################
                    _this.config.state === _Options["default"].SERVER_STATE_DEVELOPMENT ? console.log("Start Monitoring NFC Devices By Hardware Name ") : null; //###############################################################

                    _context32.next = 12;
                    return mUSBDetect.stopMonitoring();

                  case 12:
                    _context32.next = 14;
                    return mUSBDetect.startMonitoring();

                  case 14:
                  case "end":
                    return _context32.stop();
                }
              }
            }, _callee32);
          }));

          return function (_x38) {
            return _ref32.apply(this, arguments);
          };
        }())["catch"]( /*#__PURE__*/function () {
          var _ref33 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee33(error) {
            return _regenerator["default"].wrap(function _callee33$(_context33) {
              while (1) {
                switch (_context33.prev = _context33.next) {
                  case 0:
                    console.error(error);

                  case 1:
                  case "end":
                    return _context33.stop();
                }
              }
            }, _callee33);
          }));

          return function (_x39) {
            return _ref33.apply(this, arguments);
          };
        }());
      }
    } else {
      throw Error("MODULE `usb-detection` not Installed. Please Installed First");
    }

    return this;
  }

  (0, _createClass2["default"])(Nfc, null, [{
    key: "KEY_TYPE_A",
    get: function get() {
      //**********************************************************************
      return checkModuleExist("nfc-pcsc") ? require("nfc-pcsc").KEY_TYPE_A : null; //**********************************************************************
    }
  }, {
    key: "KEY_TYPE_B",
    get: function get() {
      //**********************************************************************
      return checkModuleExist("nfc-pcsc") ? require("nfc-pcsc").KEY_TYPE_B : null; //**********************************************************************
    }
  }]);
  return Nfc;
}();

var _default = Nfc;
exports["default"] = _default;
//# sourceMappingURL=index.js.map