<?php


class Encryption
{

    // No Attribute

    // No Constructor

    /** ================================================================================================
     * Start : Create Function "salt_enkripsi_pass()"
     * ----------------------------------------------
     * Deskripsi Function :
     * --------------------
     * Function yang berfungsi untuk membuat
     * Salt Password kedua.
     * -------------------------------------
     * Attribute :
     * -----------
     * - [current salt]
     * - [trigger salt]
     * -------------------------------------------------------------------------------------------------
     */
    public static function salt_enkripsi_pass($curr_salt, $trigger_salt) {

        # Variable for define input function
        $salt_saat_ini = base64_encode($curr_salt);
        $pemicu_salt = base64_encode($curr_salt . md5($trigger_salt));

        # ==============================
        # Start : Encryption Random Salt
        # ------------------------------
        $salt_all_enkrip = base64_encode($salt_saat_ini);
        $salt_all_enkrip = hash('sha512', base64_encode($salt_all_enkrip) . base64_encode($pemicu_salt));
        # -----
        # End : Encryption Random Salt
        # ============================

        # ----------------
        # Tampilkan Salt 1
        # ----------------
        return $salt_all_enkrip;

    }
    /** ------------------------------------------------------------------------------------------------
     * End : Create Function "salt_enkripsi_pass()"
     * ================================================================================================= */

    /** ================================================================================================
     * Start : Create Function "salt_enkripsi()"
     * -----------------------------------------
     * Deskripsi Function :
     * --------------------
     * Function yang berfungsi untuk membuat
     * Salt Username dan Password.
     * -------------------------------------
     * Attribute Function :
     * --------------------
     * No Attribute Function.
     * ------------------------------------------------------------------------------------------------- */
    public static function salt_enkripsi() {

        # -------------------------------------------
        # Start : Blowfish Format 1 for tells 'crypt'
        # -------------------------------------------
        $bfish_pre_1 = '$2y$07$';
        $bfish_end_1 = '$';
        # -----------------------------------------
        # End : Blowfish Format 1 for tells 'crypt'
        # -----------------------------------------

        # ------------------------------
        # Start : Generate Random Salt 1
        # ------------------------------
        $random_salt1 = hash('sha512', uniqid(mt_rand(1, mt_getrandmax()), true));
        $random_salt2 = crypt(hash('sha512', uniqid(mt_rand(1, mt_getrandmax()), true)), $bfish_pre_1 . $random_salt1 . $bfish_end_1);
        $random_salt3 = crypt($random_salt2, $bfish_pre_1 . $random_salt2 . $bfish_end_1);
        # ----------------------------
        # End : Generate Random Salt 1
        # ----------------------------

        # -------------------------------------------
        # Start : Blowfish Format 2 for tells 'crypt'
        # -------------------------------------------
        $bfish_pre_2 = '$2y$05$';
        $bfish_end_2 = '$';
        # End : Blowfish Format 2 for tells 'crypt'

        # --------------------------------
        # Start : FORMAT for Random Salt 2
        # --------------------------------
        $chars = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789./';
        $leng_chars = 63;
        # End : FORMAT for Random Salt 2

        # ---------------------------------------
        # Start : Loop for Generate Random Salt 2
        # ---------------------------------------
        $counter = 0;
        $leng_chars_salt = 101;
        $salt_one = "";
        while ($counter <= $leng_chars_salt) {
            $salt_one .= $chars[mt_rand(0, $leng_chars)];
            $counter++;
        }
        # End : Loop for Generate Random Salt 2

        # --------------------------------
        # Start : Encryption Random Salt 2
        # --------------------------------
        $salt_one = base64_encode($salt_one);
        $salt_one = crypt(base64_encode($salt_one), $bfish_pre_2 . $salt_one . $bfish_end_2);
        #$salt_one = hash('sha512', $salt_one . $random_salt1);
        #$salt_one = hash('sha512', $salt_one . $random_salt2);
        #$salt_one = hash('ripemd320', $salt_one . $random_salt1);
        #$salt_one = hash('ripemd320', $salt_one . $random_salt2);
        $salt_one = crypt($salt_one, $random_salt3);
        $salt_one = hash('sha512', base64_encode(crypt($salt_one, $random_salt3)));
        $salt_one = base64_encode(base64_encode(crypt($salt_one, $random_salt3)));
        $salt_one = crypt($salt_one, $bfish_pre_2.$random_salt1.$bfish_end_2);
        $salt_one = substr($salt_one,7);
        # End : Encryption Random Salt 2

        # ----------------
        # Tampilkan Salt 1
        # ----------------
        return $salt_one;

    }
    /** ------------------------------------------------------------------------------------------------
     * End : Create Function "salt_enkripsi()"
     * ================================================================================================= */

    /** ================================================================================================
     * Start : Create Function "blowfish_encrypt()"
     * --------------------------------------------
     * Deskripsi Function :
     * --------------------
     * Function yang berfungsi untuk menghasilkan
     * Authentication Key.
     * ------------------------------------------
     * Attribute Function :
     * --------------------
     * - $string -> Variable for define String will be Encryption;
     * ------------------------------------------------------------------------------------------------- */
    public function blowfish_encrypt($string) {

        /** ======================================
         * Create Salt for Blowfish Encryption :
         * ------------------------------------- */
        $salt = self::salt_enkripsi();

        /** ========================================
         * Prepare to create blowfish encryption :
         * --------------------------------------- */
        $blow_pre = '$2y$05$';
        $blow_end = '$';
        $blowfish_salt = $blow_pre . $salt . $blow_end;

        /** =============================
         * Create Blowfish encryption :
         * ---------------------------- */
        $blowfish = crypt($string, $blowfish_salt);
        $blowfish_final = substr($blowfish, 7);

        /** ================
         * Return Result :
         * --------------- */
        return $blowfish_final;

    }
    /** ------------------------------------------------------------------------------------------------
     * End : Create Function "blowfish_encrypt()".
     * ================================================================================================= */

    /** ================================================================================================
     * Start : Create Function "string_acak()"
     * ---------------------------------------
     * Deskripsi Function :
     * --------------------
     * Function yang berfungsi untuk melakukan
     * acak terhadap string yang dimasukkan.
     * ---------------------------------------
     * Attribute Function :
     * --------------------
     * - $string => Variable for define input string.
     * ------------------------------------------------------------------------------------------------- */
    public function string_acak($string) {

        /** =================================
         * Convert String to Array Format :
         * -------------------------------- */
        $arr_string = str_split($string, 1);
        $time = time();
        $key = substr($time, 7);
        $step1_acak = array();
        $step2_acak = array();
        $result_str_acak = '';

        /** ================================================================================
         * Start : Step 1 - Create Array for prepare Acak String
         * -------------------------------------------------------
         * Prepare Loop for Create Array for prepare Acak String :
         * --------------------------------------------------------------------------------- */
        $forward = 65;
        $until_loop_forward = 123;
        $reverse = 123;

        /** ------------------------------------------------
         * Loop for Create Array for prepare Acak String :
         * ----------------------------------------------- */
        while ($forward < $until_loop_forward) {

            /** ------------------------
             * Membuat Nilai Array mulai
             * dari angka 255 - 32 :
             * --------------------- */
            $reverse = $reverse - 1;

            /** --------------------------------------
             * Melakukan konversi desimal ke hexa :
             * ------------------------------------ */
            $value_array = chr($reverse);

            /** ----------------------------------
             * Create Key and value array with
             * based char number $revese :
             * --------------------------------- */
            $step1_acak[chr($forward)] = $value_array;

            /** ----------------------
             * Auto Increment Loop :
             * --------------------- */
            $forward++;

        }
        /** --------------------------------------------------------------------------------
         * End of Loop for Create Array for prepare Acak String.
         * -----------------------------------------------------
         * End : Step 1 - Create Array for prepare Acak String.
         * ================================================================================= */

        /** ================================================================================
         * Start : Step 2 - Convert all value array $arr_string using array $step1_acak
         * ---------------------------------------------------------------------------------
         * Prepare to convert array $arr_string to value array $step1_acak :
         * ----------------------------------------------------------------- */
        $i = 0;
        $until_loop_str = sizeof($arr_string);

        /** -----------------------------------------------------------------
         * Loop to convert array $arr_string to value array $arr_str_acak :
         * ---------------------------------------------------------------- */
        while ($i < $until_loop_str) {

            /** =========================================================
             * Placing value array $arr_string into array $step2_acak :
             * -------------------------------------------------------- */
            $step2_acak[] = $step1_acak[$arr_string[$i]];

            /** ----------------------
             * Auto Increment Loop :
             * --------------------- */
            $i++;
        }
        /** -------------------------------------------------------------------
         * End of loop to convert array $arr_string to value array $step2_acak.
         * ---------------------------------------------------------------------------------
         * End : Step 2 - Convert all value array $arr_string using array $step2_acak.
         * ================================================================================= */

        /** ================================================================================
         * Start : Final - Merge value array $step2_acak into variable $result_str_acak
         * ---------------------------------------------------------------------------------
         * Prepare loop to merge value array $step2_acak into variable $result_str_acak :
         * ------------------------------------------------------------------------------ */
        $i = 0;
        $until_loop_result = sizeof($step2_acak);

        /** -----------------------------------------------------------------------
         * Loop to marge value array $step2_acak into variable $result_str_acak :
         * ---------------------------------------------------------------------- */
        while ($i < $until_loop_result) {

            /** ======================================
             * Placing value of array $step2_acak into
             * variable $result_str_acak :
             * --------------------------- */
            $result_str_acak .= $step2_acak[$i];

            /** =================
             * Auto Increment :
             * ---------------- */
            $i++;
        }
        /** --------------------------------------------------------------------------
         * End of loop to merge value array $step2_acak into variable $result_str_acak.
         * ---------------------------------------------------------------------------- */

        /** ================
         * Return result :
         * --------------- */
        return $result_str_acak;
    }
    /** ------------------------------------------------------------------------------------------------
     * End : Create Function "string_acak()".
     * ================================================================================================= */

    /** ================================================================================================
     * Start : Create Function "nkti_hash_encrypt()"
     * ---------------------------------------------
     * Deskripsi Function :
     * --------------------
     * Function yang berfungsi untuk membuat enkripsi dimana
     * Enkripsi dibuat berdasarkan :
     * 1. Salt Encryption
     * 2. String yang akan dienkripsi
     * 3. Tanggal Format Time Stamp
     * ------------------------------------------------------------
     * Attribute Function :
     * --------------------
     * - [First Salt Encryption],
     * - [Be encryption], dan
     * - [tanggal-registrasi]);
     * ------------------------------------------------------------------------------------------------- */
    public function hash_encrypt($fist_salt_encryption, $be_encrypt, $date_reg) {

        # ------------------------------------
        # Blowfish Format for tell 'crypt' :
        # ----------------------------------
        $blow_pre = '$2y$05$';
        $blow_end = '$';

        # --------------------------
        # Create Salt Encryption :
        # ------------------------
        $second_salt_encryption = hash('sha512', $fist_salt_encryption);

        # -------------------------------
        # Start : New Salt Encryption :
        # -----------------------------
        $new_salt_encryption = $fist_salt_encryption . $second_salt_encryption;
        # -----
        # End : New Salt Encryption.
        # --------------------------

        # ------------------------------
        # Variabel for Blowfish Salt :
        # ----------------------------
        $blow_salt1 = $blow_pre . $new_salt_encryption . $blow_end;

        # ----------------------------------------
        # Start : Create Semi Final Encryption :
        # --------------------------------------
        $semi_final_encryption = base64_encode($be_encrypt);
        $semi_final_encryption = md5($semi_final_encryption);
        $semi_final_encryption = crypt($semi_final_encryption, $semi_final_encryption);
        $semi_final_encryption = hash('sha512', $semi_final_encryption . $be_encrypt);
        $semi_final_encryption = $semi_final_encryption . $fist_salt_encryption . $second_salt_encryption;
        $semi_final_encryption = crypt($semi_final_encryption, $blow_salt1);
        # ------
        # End : Create Semi Final Encryption.
        # -----------------------------------

        # ------------------------------
        # Variabel for Blowfish Salt :
        # ----------------------------
        $blow_salt2 = $blow_pre . $semi_final_encryption . $blow_end;

        # ----------------------------------
        # Start : Create Hash Encryption :
        # --------------------------------
        $hash_encryption = crypt($semi_final_encryption, $blow_salt2);
        $date_encryption = crypt(md5($date_reg), $blow_salt2);
        $hash_encryption = $hash_encryption . $date_encryption;
        $hash_encryption = crypt($hash_encryption, $blow_salt2);
        $hash_encryption = crypt($hash_encryption, md5($second_salt_encryption));
        # -----
        # End : Create Hash Encryption.
        # -----------------------------

        # ------------------------------------
        # Start : Prepare Final Encryption :
        # ----------------------------------
        $prepare_final_encryption = base64_encode($be_encrypt);
        $prepare_ending_encryption = md5($hash_encryption);
        $pre_div_prepare_ending_encryption = substr($prepare_ending_encryption, 0,16);
        $end_div_prepare_ending_encryption = substr($prepare_ending_encryption, 16);
        # -------------------------------
        # End : Prepare Final Encryption.
        # -------------------------------

        # ----------------------------
        # Start : Final Encryption :
        # --------------------------
        // $final_encryption = $hash_encryption .' ['. strlen($hash_encryption) .'] '. $prepare_final_encryption .' ['. strlen($prepare_final_encryption) .'] '. $prepare_ending_encryption .' ['. strlen($prepare_ending_encryption) .'] ';
        $final_encryption = $pre_div_prepare_ending_encryption . $hash_encryption . $prepare_final_encryption . $end_div_prepare_ending_encryption;
        $final_encryption = base64_encode($final_encryption);
        $final_encryption = base64_encode($final_encryption);
        # -----------------------
        # End : Final Encryption.
        # -----------------------

        # ---------------------------------
        # Untuk Mencetak Hasil Enkripsi :
        # -------------------------------
        return $final_encryption;

    }
    /** ------------------------------------------------------------------------------------------------
     * End : Create NKTI Hash Enkripsi.
     * ================================================================================================= */

    /** ================================================================================================
     * Start : Create Function "nkti_hash_decryption"
     * ----------------------------------------------
     * Deskripsi Function :
     * --------------------
     * Function yang berfungsi untuk melakukan
     * Dekripsi.
     * ---------------------------------------
     * Format Deskripsi Function :
     * ---------------------------
     * [Hash Encryption]
     * ------------------------------------------------------------------------------------------------- */
    public function hash_decryption($hash_encryption) {

        # ============================
        # Mappings Hash Encryption :
        # --------------------------
        $base64_dec = base64_decode(base64_decode($hash_encryption));
        $length_hash_encyrption = strlen($base64_dec);
        $get_encrypt_end = ($length_hash_encyrption - 16);
        $mappings_first = substr($base64_dec, 16,($get_encrypt_end));

        # ===========================
        # Prepare Hash Decryption :
        # -------------------------
        # Hilangkan 13 Karakter didepan string :
        $first_step_decryption = substr($mappings_first, 13);

        # =====================================================
        # Hitung jumlah string saat ini, kemudian kurang 16 :
        # ===================================================
        $length_first_step_decryption = strlen($first_step_decryption) - 16;

        # ==============================================================
        # Ambil String mulai dari 0 sampai jumlah yang dihasilkan oleh
        # Variable "$length_first_step_decryption" :
        # ------------------------------------------
        $second_step_decryption = substr($first_step_decryption, 0,$length_first_step_decryption);

        # ========================
        # Final hash Decryption :
        # -----------------------
        $final_hash_decryption = base64_decode($second_step_decryption);

        # =====================
        # Result Decryption :
        # -------------------
        return $final_hash_decryption;

    }
    /** ------------------------------------------------------------------------------------------------
     * End : Create Function "nkti_hash_decryption"
     * ================================================================================================= */

    /** ================================================================================================
     * Start : Create Function "encrypt_username()"
     * --------------------------------------------
     * Deskripsi Function :
     * --------------------
     * Function yang berfungsi untuk membuat enkripsi
     * Username.
     * ----------------------------------------------
     * Attribute Function :
     * --------------------
     * - [username]
     * ------------------------------------------------------------------------------------------------- */
    public function encrypt_username($username) {

        # ===========================
        # Variable for Encryption :
        # -------------------------
        $first_prepare_enrypt_username = md5('sekolah' . 'terbaik');
        $second_prepare_encryt_username = md5($username);
        $hash_uname = hash('sha512', base64_encode(md5($first_prepare_enrypt_username.$second_prepare_encryt_username)));

        # =====================================
        # Tampilkan Hasil Enkripsi Username :
        # -----------------------------------
        return $hash_uname;

    }
    /** ------------------------------------------------------------------------------------------------
     * End : Create Function "encrypt_username()"
     * ================================================================================================= */

    /** ================================================================================================
     * Start : Create Function "encrypt_password()"
     * --------------------------------------------
     * Deskripsi Function :
     * --------------------
     * Function yang berfungsi untuk membuat HASH Password,
     * dimana HASH Password di buat berdasarkan :
     * 1. Password yang di input pada menu registrasi,
     * 2. Salt Password,
     * 3. Tanggal Registrasi User.
     * ----------------------------------------------------
     * Attribute Function :
     * --------------------
     * - [password],
     * - [salt password], dan
     * - [date_reg]
     * ------------------------------------------------------------------------------------------------- */
    public function encrypt_password($pass, $salt_password, $date_reg) {

        # -------------------------------
        # Start : First Enkripsi Password
        # -------------------------------
        $pass2 = base64_encode($pass);
        $pass2 = hash('sha512', $pass2);
        # End : First Enkripsi Password

        # -----------------------------
        # Start : First Blowfish Format
        $blow_pre = '$2y$05$';
        $blow_end = '$';
        # End : First Blowfish Format
        # ---------------------------

        # ---------------------
        # Start : Enkripsi Salt
        $salt = md5($salt_password);
        $blow_salt1 = $blow_pre . $salt_password . $blow_end;
        $blow_salt2 = $blow_pre . $salt . $blow_end;
        $salt = crypt($salt, $blow_salt1);
        $date_salt = crypt($date_reg, $blow_salt2);
        $date_salt = crypt($date_salt . $salt_password, $blow_salt2);
        $salt_temp1 = $salt . $date_salt;
        $blow_salt3 = $blow_pre . $salt_temp1 . $blow_end;
        $salt_temp2 = hash('sha512', $blow_salt3);
        $salt = hash('sha512', $salt_temp2);
        # End : Enkripsi Salt

        # ------------------------------
        # Start : Second Blowfish Format
        $blow_pre_2 = '$2y$07$';
        $blow_end_2 = '$';
        # End : Second Blowfish Format

        # ------------------------------
        # Start : Blowfish Salt Variable
        $blow_salt4 = $blow_pre_2 . $salt . $blow_end_2;
        # End : Blowfish Salt Variable

        # ----------------------------
        # Start : Create HASH Password
        $hash_pass = crypt($pass2, $blow_salt4);
        $hash_pass = substr($hash_pass,7);
        # End : Create HAHS Password

        # ----------------------------
        # Untuk mencetak HASH Password
        return $hash_pass;
    }
    /** ------------------------------------------------------------------------------------------------
     * End : Create Function "encrypt_password()".
     * ================================================================================================= */

    /** ===============================================================================================
     * Start : Create Function "nkti_session_encryption()"
     * ---------------------------------------------------
     * Deskripsi Function :
     * --------------------
     * Function yang berfungsi untuk melakukan Enkripsi
     * Nama Session dan Isi Session.
     * ------------------------------------------------
     * Attribute Function :
     * --------------------
     * - $string -> Variable yang berisi Enkripsi.
     * - $key -> Variable yang berisi key untuk melakukan enkripsi,
     *           dan hanya diperbolehkan angka yang berjumlah 3 atau 10.
     * ------------------------------------------------------------------------------------------------ */
    public static function session_encryption($string, $key) {

        # ================================
        # Prepare for Doing Encryption :
        # ----------------------------------------------------
        # Define Variable for Prepare String to Encryption :
        # --------------------------------------------------
        $string = base64_encode($string);

        # ---------------------------
        # Convert String into array :
        # ---------------------------
        $string_to_array = str_split($string, 1);

        # =============================
        # Start : Step 1 Encryption :
        # ---------------------------
        # Prepare Loop for Create Step 1 Encryption :
        # -------------------------------------------
        $forward = 32;
        $until_loop_forward = 255;
        $reverse = 255;
        $step_1_encryption = array();

        # -------------------------------------
        # Loop for Create Step 1 Encryption :
        # -----------------------------------
        while ($forward < $until_loop_forward) {

            # -------------------------
            # Membuat Nilai Array mulai
            # dari angka 255 - 32 :
            # ---------------------
            $reverse = $reverse - 1;

            # --------------------------------------
            # Melakukan konversi desimal ke hexa :
            # ------------------------------------
            $value_array = dechex($reverse + $key);

            # -----------------------------------
            # Create Key and value array with
            # ((value array * 7) - (21 + 25)) :
            # ---------------------------------
            $step_1_encryption[chr($forward)] = $value_array;
            $forward++;

        }
        # End of Loop for Create Step 1 Encryption.
        # -----------------------------------------
        # End : Step 1 Encryption.
        # ========================

        # ===========================
        # Start : Step 2 Encryption :
        # ---------------------------
        # Prepare Loop For Create Step 2 Encryption :
        # -------------------------------------------
        $i = 0;
        $until_loop = sizeof($string_to_array);
        $step_2_encryption = '';
        $step_21_encryption = array();

        # -------------------------------------
        # Loop For Create Step 2 Encryption :
        # -----------------------------------
        while ($i < $until_loop) {

            # -----------------------------------
            # Create String from source value of
            # array "$step_1_encryption"
            # --------------------------
            $step_2_encryption .= $step_1_encryption[$string_to_array[$i]];
            $step_21_encryption[$i] = $step_1_encryption[$string_to_array[$i]];

            # ----------------
            # Auto Increment :
            # ----------------
            $i++;

        }
        # End of Loop For Create Step 2 Encryption.
        # -----------------------------------------

        # =========================
        # Start : Step 2 Encryption
        # -----------------------------
        # Array for encrypt character :
        # -----------------------------
        $char_encode = array(
            "a" => "t",
            "b" => "l",
            "c" => "n",
            "d" => "k",
            "e" => "p",
            "f" => "r"
        );

        # ----------------------------------------
        # Change character alpabetis hexadecimal :
        # ----------------------------------------
        $step_2_encryption = str_replace('a', $char_encode['a'], $step_2_encryption); # character "a".
        $step_2_encryption = str_replace('b', $char_encode['b'], $step_2_encryption); # character "b".
        $step_2_encryption = str_replace('c', $char_encode['c'], $step_2_encryption); # character "c".
        $step_2_encryption = str_replace('d', $char_encode['d'], $step_2_encryption); # character "d".
        $step_2_encryption = str_replace('e', $char_encode['e'], $step_2_encryption); # character "e".
        $step_2_encryption = str_replace('f', $char_encode['f'], $step_2_encryption); # character "f".
        # ------------------------
        # End : Step 2 Encryption.
        # ========================

        # =============================
        # Start : Step 3 Encryption :
        # ---------------------------
        # Define Variable for Prepare Encryption :
        # ----------------------------------------
        $string_abc = 'ZXCIOPQWEBNMKLJDASHGFRYUTV';
        $string_abc = str_split($string_abc, 1);

        # ----------------------------------------------------------
        # Prepare Loop for create Array Encode Step 3 Encryption :
        # --------------------------------------------------------
        $i = 0;
        $num_start = 0;
        $until_loop = sizeof($string_abc);
        $pre_step3_encryption = array();

        # --------------------------------------------------
        # Loop for create Array Encode Step 3 Encryption :
        # ------------------------------------------------
        while ($i < $until_loop) {

            # ------------------------------
            # Increment For Number Array :
            # ----------------------------
            $num_start = $num_start + 1;

            # ------------------------------------------
            # Create New Array for Step 3 Encryption :
            # ----------------------------------------
            $pre_step3_encryption[$i] = $string_abc[$i];

            # ------------------
            # Auto Increment :
            # ----------------
            $i++;

        }
        # End of Loop for create Array Encode Step 3 Encryption.
        # ------------------------------------------------------

        # --------------------------------
        # Array From Step 2 Encryption :
        # ------------------------------
        $array_step2_encryption = str_split($step_2_encryption, 1);

        # ------------------------------------------
        # Variable for placing Step 3 Encryption :
        # ----------------------------------------
        $step3_encryption = '';

        # ----------------------------------
        # Create Final Step 3 Encryption :
        # --------------------------------
        # Prepare Loop for Create Step 3 Encryption :
        # -------------------------------------------
        $i = 0;
        $until_loop = sizeof($array_step2_encryption);

        # -------------------------------------
        # loop for Create Step 3 Encryption :
        # -----------------------------------
        while ($i < $until_loop) {

            # ------------------------------------------
            # Parse Integer data into value of array :
            # ----------------------------------------
            $int_parse = preg_match('/^[0-9]*$/', $array_step2_encryption[$i]);

            # -----------------------------------------
            # IF Interger data founded in value array :
            # -----------------------------------------
            if ($int_parse == true) {

                # ----------------------------------------------------------------
                # Create string from source value of Array "$pre_step3_encryption"
                # with key from value array "$array_step2_encryption" :
                # -----------------------------------------------------
                $step3_encryption .= $pre_step3_encryption[$array_step2_encryption[$i]];
            }
            # End of get IF Interger data founded in value array.
            # ---------------------------------------------------

            # ----------------------------------------------
            # IF Integer data not founded in value array :
            # --------------------------------------------
            else {
                $step3_encryption .= $array_step2_encryption[$i];
            }
            # End of get IF Integer data not founded in value array.
            # ------------------------------------------------------

            # ------------------
            # Auto Increment :
            # ----------------
            $i++;

        }
        # End of Loop For Create Step 3 Encryption.
        # -----------------------------------------
        # End : Step 3 Encryption.
        # ========================

        # ============================
        # Return Step 3 Encryption :
        # --------------------------
        return $step3_encryption;
//        return $step_21_encryption;

    }
    /** ------------------------------------------------------------------------------------------------
     * End : Create Function "nkti_session_encryption()"
     * ================================================================================================= */

    /** ================================================================================================
     * Start : Create Function "nkti_session_decryption()"
     * ---------------------------------------------------
     * Deskripsi Function :
     * --------------------
     * Function yang berfungsi untuk melakukan deskripsi
     * terhadap enkripsi session yang telab dibuat.
     * -------------------------------------------------
     * Attribute Function :
     * --------------------
     * - $encrypt -> Variable yang berisi Enkripsi.
     * - $key -> Variable yang berisi key yang digunkaan sebelumnya untuk
     *           melakukan Enkripsi. Key ini berisi 3 angka atau 10 angka.
     * ------------------------------------------------------------------------------------------------- */
    public static function session_decryption($encrypt, $key) {

        # =========================
        # Start : Step 1 Decryption
        # ------------------------------------------
        # Define Variable for Prepare Encryption :
        # ----------------------------------------
        $string_abc = 'ZXCIOPQWEBNMKLJDASHGFRYUTV'; // Original String
        $string_abc = str_split($string_abc, 1); // Convert String into array

        # --------------------------------------
        # Create Array For Step 1 Decryption :
        # ------------------------------------
        # Prepare For Create Array Step 1 Decryption :
        # --------------------------------------------
        $i = 0;
        $until_loop_array_decryption_step1 = sizeof($string_abc);
        $pre_step1_decryption = array();

        # -------------------------------------------
        # Loop for Create Array Step 1 Decryption :
        # -----------------------------------------
        while ($i < $until_loop_array_decryption_step1) {

            # ================================================
            # Placing data array "$pre_step1_decryption" with
            # key from sournce array "$string_abc" and value
            # from "Auto Increment" :
            # -----------------------
            $pre_step1_decryption[$string_abc[$i]] = $i;

            # ------------------
            # Auto Increment :
            # ----------------
            $i++;
        }
        # End of Loop for Create Array Step 1 Decryption.
        # -----------------------------------------------

        # --------------------------------------
        # Convert Encryption String to Array :
        # ------------------------------------
        $encrypt_arr = str_split($encrypt, 1);

        # --------------------------
        # Create Step 1 Decryption :
        # ---------------------------------------------
        # Prepare Loop for Create Step 1 Decryption :
        # -------------------------------------------
        $i = 0;
        $until_loop = sizeof($encrypt_arr);
        $step1_decryption = '';

        # -------------------------------------
        # Loop For Create Step 1 Decryption :
        # -----------------------------------
        while ($i < $until_loop) {

            # ------------------------------------------
            # Variable for define parse Integer data :
            # ----------------------------------------
            $int_parse = preg_match('/^[A-Z]*$/', $encrypt_arr[$i]);

            # ----------------------------------------
            # IF integer data founded in value array :
            # ----------------------------------------
            if ($int_parse == true) {

                # -------------------------------------------------------------------
                # Create string from source value array "$pre_step1_decryption"
                # and key array "$pre_step1_decryption" from value array "$encrypt" :
                # -------------------------------------------------------------------
                $step1_decryption .= $pre_step1_decryption[$encrypt_arr[$i]];
            }
            # End of get IF integer data founded in value array.
            # ----------------------------------------------------

            # ----------------------------------------------
            # IF integer data not founded in value array :
            # --------------------------------------------
            else {

                # -----------------------------------------------
                # Create String from source array "$encrypt" with
                # Key from "Auto Increment" :
                # ---------------------------
                $step1_decryption .= $encrypt_arr[$i];
            }
            # End of get IF integer data not founded in value array.
            # --------------------------------------------------------

            # ------------------
            # Auto Increment :
            # ----------------
            $i++;
        }
        # End of Loop For Create Step 1 Decryption.
        # -----------------------------------------
        # End : Step 1 Decryption.
        # ========================

        # =========================
        # Start : Step 2 Decryption
        # -----------------------------
        # Array for encrypt character :
        # -----------------------------
        $char_encode = array(
            "t" => "a",
            "l" => "b",
            "n" => "c",
            "k" => "d",
            "p" => "e",
            "r" => "f"
        );

        # --------------------------------------
        # Change character alpabetis hexadecimal
        # --------------------------------------
        $step1_decryption = str_replace('t', $char_encode['t'], $step1_decryption); # character "t".
        $step1_decryption = str_replace('l', $char_encode['l'], $step1_decryption); # character "l".
        $step1_decryption = str_replace('n', $char_encode['n'], $step1_decryption); # character "n".
        $step1_decryption = str_replace('k', $char_encode['k'], $step1_decryption); # character "k".
        $step1_decryption = str_replace('p', $char_encode['p'], $step1_decryption); # character "p".
        $step1_decryption = str_replace('r', $char_encode['r'], $step1_decryption); # character "r".

        # --------------------------------------
        # Convert String Encryption into Array :
        # --------------------------------------
        # IF variable $key == 10 :
        # ------------------------
        if (strlen($key) == 10) {

            # -----------------------------------------------
            # Define variable $encrypt with value from result
            # split string "$step1_decryption" per 8 char :
            # ---------------------------------------------
            $encrypt = str_split($step1_decryption, 8);

        }
        # End of get IF variable $key == 10.
        # ------------------------------------

        # -------------------------
        # IF variable $key == 3 :
        # -----------------------
        elseif (strlen($key) == 3) {

            # -----------------------------------------------
            # Define variable $encrypt with value from result
            # split string $step1_decryption per 3 char :
            # -------------------------------------------
            $encrypt = str_split($step1_decryption, 3);
        }
        # End of get IF variable $key == 3.
        # -----------------------------------

        # -------------------------------
        # Declare Array for result encode
        # Step 2 Decryption :
        # -------------------------------
        $string_step2_decryption = array();

        # --------------------------------------------------
        # Prepare Loop Array for Prepare Step 2 Decyrption :
        # --------------------------------------------------
        $i = 0;
        $until_loop = sizeof($encrypt);

        # ------------------------------------------
        # Loop for Array Prepare Step 2 Decryption :
        # ------------------------------------------
        while ($i < $until_loop) {

            # --------------------------------------
            # Placing Result Convert Hex to Dec into
            # array "$string_step2_decryption" :
            # ----------------------------------
            $string_step2_decryption[] = hexdec($encrypt[$i]) - $key;

            # ------------------
            # Auto Increment :
            # ----------------
            $i++;
        }
        # End of Loop for Array Prepare Step 2 Decryption.
        # ------------------------------------------------
        # End : Step 2 Decryption.
        # ========================

        # =========================
        # Start : Step 3 Decryption
        # ------------------------------------
        # Create Array for Step 2 Decryption :
        # ------------------------------------------
        # Prepare Loop Array for Array Encode char :
        # ------------------------------------------
        $reverse = 254;
        $until_loop_reverse = 31;
        $forward = 31;
        $array_for_decryption = array();

        # -----------------------------------
        # Loop Array for Create Encode char :
        # -----------------------------------
        while ($reverse > $until_loop_reverse) {

            # --------------------------
            # Variable for define number
            # start 33 until 255 :
            # --------------------
            $forward = $forward + 1;

            # ----------------------------------------------------
            # Placing data array "$array_for_decryption" with key
            # From source value of variable "$reverse", then value
            # of array "$array_for_decryption" from source result
            # convert number char to original char :
            # --------------------------------------
            $array_for_decryption[$reverse] = chr($forward);

            /** -----------------
             * Auto Decrement :
             * ---------------- */
            $reverse--;

        }
        # End of Loop Array for Create Encode Char.
        # -----------------------------------------

        # ------------------------------------
        # Prepare Loop Array For Encode Char :
        # ------------------------------------
        $i = 0;
        $until_loop_encode_char = sizeof($string_step2_decryption);
        $step_3_decryption = '';

        # ----------------------------
        # Loop Array for Encode Char :
        # ----------------------------
        while ($i < $until_loop_encode_char) {

            # ---------------------------------------------------
            # Define variable "$key_for_access_array" with value
            # from value array "$string_step2_decryption" and key
            # from "Auto Increment" :
            # -----------------------
            $key_for_access_array = $string_step2_decryption[$i];

            # ----------------------------------------------------------------------------
            # Create string for variable "$step_3_decryption with value of variable from
            # value of array "$array_for_decryption" and key array "$array_for_decryption"
            # from value of variable "$key_for_access_array" :
            # ------------------------------------------------
            $step_3_decryption .= $array_for_decryption[$key_for_access_array];

            # ------------------
            # Auto Increment :
            # ----------------
            $i++;

        }
        # End of Loop Array For Encode Char.
        # ----------------------------------
        # End : Step 3 Decryption.
        # ========================

        # ====================
        # Final Decryption :
        # ------------------
        $final_decryption = base64_decode($step_3_decryption);
//        $final_decryption = $step_3_decryption;

        # ===========================
        # Return Final Decryption :
        # -------------------------
        return $final_decryption;
//        return $string_step2_decryption;
    }
    /** ------------------------------------------------------------------------------------------------
     * End : Create Function "nkti_session_decryption()".
     * ================================================================================================= */

    /** ================================================================================================
     * Start : Create Function "nkti_enkripsi()"
     * -------------------------------------------------------------------------------------------------
     * Dekripsi Function :
     * -------------------
     * Function yang berfungsi untuk melakukan enkripsi
     * terhadap string baik dalam bentuk angka maupun numerik.
     * -------------------------------------------------------
     * Attribute Function :
     * --------------------
     * - $string -> Variable yang berisi String untuk dienkripsi.
     * - $key -> Variable yang berisi key untuk melakukan enkripsi,
     *           dan hanya diperbolehkan angka yang berjumlah 3 atau 10.
     * ------------------------------------------------------------------------------------------------- */
    public static function enkripsi($string, $key) {

        /** ============================
         * Convert String into array :
         * --------------------------- */
        $string_to_array = str_split($string, 1);

        /** ================================================================================
         * Start : Step 1 Encryption :
         * ---------------------------------------------------------------------------------
         * Prepare Loop for Create Step 1 Encryption :
         * ------------------------------------------------------------- */
        $forward = 32;
        $until_loop_forward = 255;
        $reverse = 255;
        $step_1_encryption = array();

        /** -------------------------------------
         * Loop for Create Step 1 Encryption :
         * ----------------------------------- */
        while ($forward < $until_loop_forward) {

            /** -------------------------
             * Membuat Nilai Array mulai
             * dari angka 255 - 32 :
             * --------------------- */
            $reverse = $reverse - 1;

            /** --------------------------------------
             * Melakukan konversi desimal ke hexa :
             * ------------------------------------ */
            $value_array = dechex($reverse + $key);

            /** -----------------------------------
             * Create Key and value array with
             * ((value array * 7) - (21 + 25)) :
             * --------------------------------- */
            $step_1_encryption[chr($forward)] = $value_array;
            $forward++;

        }
        /** ----------------------------------------
         * End of Loop for Create Step 1 Encryption.
         * ---------------------------------------------------------------------------------
         * End : Step 1 Encryption.
         * ================================================================================= */

        /** ================================================================================
         * Start : Step 2 Encryption :
         * ---------------------------------------------------------------------------------
         * Prepare Loop For Create Step 2 Encryption :
         * ------------------------------------------- */
        $i = 0;
        $until_loop = sizeof($string_to_array);
        $step_2_encryption = '';
        $step_21_encryption = array();

        /** ------------------------------------
         * Loop For Create Step 2 Encryption :
         * ----------------------------------- */
        while ($i < $until_loop) {

            /** -----------------------------------
             * Create String from source value of
             * array "$step_1_encryption"
             * -------------------------- */
            if (isset($step_1_encryption[$string_to_array[$i]])) {
                $step_2_encryption .= $step_1_encryption[$string_to_array[$i]];
                $step_21_encryption[$i] = $step_1_encryption[$string_to_array[$i]];
            } else {
                $step_2_encryption .= 'null';
                $step_21_encryption[$i] = 'null';
            }

            /** -----------------
             * Auto Increment :
             * ---------------- */
            $i++;

        }
        /** ----------------------------------------
         * End of Loop For Create Step 2 Encryption.
         * ----------------------------------------- */

        /** ================================================================================
         * Start : Step 2 Encryption
         * ---------------------------------------------------------------------------------
         * Array for encrypt character :
         * ----------------------------- */
        $char_encode = array(
            "a" => "t",
            "b" => "l",
            "c" => "n",
            "d" => "k",
            "e" => "p",
            "f" => "r"
        );

        /** -----------------------------------------
         * Change character alpabetis hexadecimal :
         * ---------------------------------------- */
        $step_2_encryption = str_replace('a', $char_encode['a'], $step_2_encryption); # character "a".
        $step_2_encryption = str_replace('b', $char_encode['b'], $step_2_encryption); # character "b".
        $step_2_encryption = str_replace('c', $char_encode['c'], $step_2_encryption); # character "c".
        $step_2_encryption = str_replace('d', $char_encode['d'], $step_2_encryption); # character "d".
        $step_2_encryption = str_replace('e', $char_encode['e'], $step_2_encryption); # character "e".
        $step_2_encryption = str_replace('f', $char_encode['f'], $step_2_encryption); # character "f".
        /** --------------------------------------------------------------------------------
         * End : Step 2 Encryption.
         * ================================================================================= */

        /** ================================================================================
         * Start : Step 3 Encryption :
         * ---------------------------------------------------------------------------------
         * Define Variable for Prepare Encryption :
         * ---------------------------------------- */
        $string_abc = 'HGJSLKDAFUYVNBTZPOXCIMERQW';
        $string_abc = str_split($string_abc, 1);

        /** ---------------------------------------------------------
         * Prepare Loop for create Array Encode Step 3 Encryption :
         * -------------------------------------------------------- */
        $i = 0;
        $num_start = 0;
        $until_loop = sizeof($string_abc);
        $pre_step3_encryption = array();

        /** -------------------------------------------------
         * Loop for create Array Encode Step 3 Encryption :
         * ------------------------------------------------ */
        while ($i < $until_loop) {

            /** -----------------------------
             * Increment For Number Array :
             * ---------------------------- */
            $num_start = $num_start + 1;

            /** -----------------------------------------
             * Create New Array for Step 3 Encryption :
             * ---------------------------------------- */
            $pre_step3_encryption[$i] = $string_abc[$i];

            /** -----------------
             * Auto Increment :
             * ---------------- */
            $i++;

        }
        /** -----------------------------------------------------
         * End of Loop for create Array Encode Step 3 Encryption.
         * ------------------------------------------------------ */

        /** -------------------------------
         * Array From Step 2 Encryption :
         * ------------------------------ */
        $array_step2_encryption = str_split($step_2_encryption, 1);

        /** -----------------------------------------
         * Variable for placing Step 3 Encryption :
         * ---------------------------------------- */
        $step3_encryption = '';

        /** ------------------------------------------------------------
         * Create Final Step 3 Encryption :
         * -------------------------------------------------------------
         * Prepare Loop for Create Step 3 Encryption :
         * ------------------------------------------- */
        $i = 0;
        $until_loop = sizeof($array_step2_encryption);

        /** -------------------------------------
         * loop for Create Step 3 Encryption :
         * ----------------------------------- */
        while ($i < $until_loop) {

            /** -----------------------------------------
             * Parse Integer data into value of array :
             * ---------------------------------------- */
            $int_parse = preg_match('/^[0-9]*$/', $array_step2_encryption[$i]);

            /** ------------------------------------------
             * IF Interger data founded in value array :
             * ----------------------------------------- */
            if ($int_parse == true) {

                /** ---------------------------------------------------------------
                 * Create string from source value of Array "$pre_step3_encryption"
                 * with key from value array "$array_step2_encryption" :
                 * ----------------------------------------------------- */
                if (isset($pre_step3_encryption[$array_step2_encryption[$i]])) {
                    $step3_encryption .= $pre_step3_encryption[$array_step2_encryption[$i]];
                } else {
                    $step3_encryption .= 'null';
                }
            }
            /** --------------------------------------------------
             * End of get IF Interger data founded in value array.
             * --------------------------------------------------- */

            /** ---------------------------------------------
             * IF Integer data not founded in value array :
             * -------------------------------------------- */
            else {

                /** ---------------------------------------------------------------
                 * Create string from source value of Array "$pre_step3_encryption"
                 * with key from value array "$array_step2_encryption" :
                 * ----------------------------------------------------- */
                $step3_encryption .= $array_step2_encryption[$i];
            }
            /** -----------------------------------------------------
             * End of get IF Integer data not founded in value array.
             * ------------------------------------------------------ */

            /** -----------------
             * Auto Increment :
             * ---------------- */
            $i++;

        }
        /** ----------------------------------------
         * End of Loop For Create Step 3 Encryption.
         * ---------------------------------------------------------------------------------
         * End : Step 3 Encryption.
         * ================================================================================= */

        # ============================
        # Return Step 3 Encryption :
        # --------------------------
        return $step3_encryption;
//        return $step_21_encryption;

    }
    /** ------------------------------------------------------------------------------------------------
     * End : Create Function "nkti_enkripsi()".
     * ================================================================================================= */

    /** ================================================================================================
     * Start : Create Function "nkti_dekripsi()"
     * -------------------------------------------------------------------------------------------------
     * Deskripsi Function :
     * --------------------
     * Function yang berfungsi untuk melakukan dekripsi
     * terhadap string enkripsi.
     * --------------------------------------------------------------
     * Attribute Function :
     * --------------------
     * - $enkrip -> Variable yang berisi Enkripsi.
     * - $key -> Variable yang berisi key yang digunkan sebelumnya untuk
     *           melakukan Enkripsi. Key ini berisi 3 angka atau 10 angka.
     * ------------------------------------------------------------------------------------------------- */
    public static function dekripsi($encrypt, $key) {

        /** ================================================================================
         * Start : Step 1 Decryption
         * ---------------------------------------------------------------------------------
         * Define Variable for Prepare Encryption :
         * ---------------------------------------- */
        $string_abc = 'HGJSLKDAFUYVNBTZPOXCIMERQW'; // Original String
        $string_abc = str_split($string_abc, 1); // Convert String into array

        /** ------------------------------------------------------------
         * Create Array For Step 1 Decryption :
         * -------------------------------------------------------------
         * Prepare For Create Array Step 1 Decryption :
         * -------------------------------------------- */
        $i = 0;
        $until_loop_array_decryption_step1 = sizeof($string_abc);
        $pre_step1_decryption = array();

        /** -------------------------------------------
         * Loop for Create Array Step 1 Decryption :
         * ----------------------------------------- */
        while ($i < $until_loop_array_decryption_step1) {

            /** ================================================
             * Placing data array "$pre_step1_decryption" with
             * key from sournce array "$string_abc" and value
             * from "Auto Increment" :
             * ----------------------- */
            $pre_step1_decryption[$string_abc[$i]] = $i;

            /** -----------------
             * Auto Increment :
             * ---------------- */
            $i++;
        }
        /** ----------------------------------------------
         * End of Loop for Create Array Step 1 Decryption.
         * ----------------------------------------------- */

        /** --------------------------------------
         * Convert Encryption String to Array :
         * ------------------------------------ */
        $encrypt_arr = str_split($encrypt, 1);

        /** --------------------------
         * Create Step 1 Decryption :
         * ---------------------------------------------
         * Prepare Loop for Create Step 1 Decryption :
         * ------------------------------------------- */
        $i = 0;
        $until_loop = sizeof($encrypt_arr);
        $step1_decryption = '';

        /** ------------------------------------
         * Loop For Create Step 1 Decryption :
         * ----------------------------------- */
        while ($i < $until_loop) {

            /** -----------------------------------------
             * Variable for define parse Integer data :
             * ---------------------------------------- */
            $int_parse = preg_match('/^[A-Z]*$/', $encrypt_arr[$i]);

            /** ----------------------------------------
             * IF integer data founded in value array :
             * ---------------------------------------- */
            if ($int_parse == true) {

                /** ------------------------------------------
                 * Create string from source value
                 * array "$pre_step1_decryption" and key
                 * array "$pre_step1_decryption" from
                 * value array "$encrypt" :
                 * ------------------------------------------- */
                if (isset($pre_step1_decryption[$encrypt_arr[$i]])) {
                    $step1_decryption .= $pre_step1_decryption[$encrypt_arr[$i]];
                } else {
                    $step1_decryption .= 'null';
                }
            }
            /** -------------------------------------------------
             * End of get IF integer data founded in value array.
             * -------------------------------------------------- */

            /** ----------------------------------------------
             * IF integer data not founded in value array :
             * -------------------------------------------- */
            else {

                /** -----------------------------------------------
                 * Create String from source array "$encrypt" with
                 * Key from "Auto Increment" :
                 * --------------------------- */
                $step1_decryption .= $encrypt_arr[$i];
            }
            /** -----------------------------------------------------
             * End of get IF integer data not founded in value array.
             * ------------------------------------------------------ */

            /** ------------------
             * Auto Increment :
             * ---------------- */
            $i++;
        }
        /** ----------------------------------------
         * End of Loop For Create Step 1 Decryption.
         * ---------------------------------------------------------------------------------
         * End : Step 1 Decryption.
         * ================================================================================= */

        /** ================================================================================
         * Start : Step 2 Decryption
         * ---------------------------------------------------------------------------------
         * Array for encrypt character :
         * ----------------------------- */
        $char_encode = array(
            "t" => "a",
            "l" => "b",
            "n" => "c",
            "k" => "d",
            "p" => "e",
            "r" => "f"
        );

        /** ---------------------------------------
         * Change character alpabetis hexadecimal
         * -------------------------------------- */
        $step1_decryption = str_replace('t', $char_encode['t'], $step1_decryption); # character "t".
        $step1_decryption = str_replace('l', $char_encode['l'], $step1_decryption); # character "l".
        $step1_decryption = str_replace('n', $char_encode['n'], $step1_decryption); # character "n".
        $step1_decryption = str_replace('k', $char_encode['k'], $step1_decryption); # character "k".
        $step1_decryption = str_replace('p', $char_encode['p'], $step1_decryption); # character "p".
        $step1_decryption = str_replace('r', $char_encode['r'], $step1_decryption); # character "r".

        /** ---------------------------------------
         * Convert String Encryption into Array :
         * --------------------------------------
         * IF variable $key == 10 :
         * ------------------------ */
        if (strlen($key) == 10) {

            /** -----------------------------------------------
             * Define variable $encrypt with value from result
             * split string "$step1_decryption" per 8 char :
             * --------------------------------------------- */
            $encrypt = str_split($step1_decryption, 8);

        }
        /** ---------------------------------
         * End of get IF variable $key == 10.
         * ---------------------------------- */

        /** -------------------------
         * IF variable $key == 3 :
         * ----------------------- */
        elseif (strlen($key) == 3) {

            /** -----------------------------------------------
             * Define variable $encrypt with value from result
             * split string $step1_decryption per 3 char :
             * ------------------------------------------- */
            $encrypt = str_split($step1_decryption, 3);
        }
        /** --------------------------------
         * End of get IF variable $key == 3.
         * --------------------------------- */

        /** ----------------------------------------------------
         * Declare Array for result encode Step 2 Decryption :
         * --------------------------------------------------- */
        $string_step2_decryption = array();

        /** --------------------------------------------------
         * Prepare Loop Array for Prepare Step 2 Decyrption :
         * -------------------------------------------------- */
        $i = 0;
        $until_loop = sizeof($encrypt);

        /** -------------------------------------------
         * Loop for Array Prepare Step 2 Decryption :
         * ------------------------------------------ */
        while ($i < $until_loop) {

            /** --------------------------------------
             * Placing Result Convert Hex to Dec into
             * array "$string_step2_decryption" :
             * ---------------------------------- */
            $string_step2_decryption[$i] = hexdec($encrypt[$i]) - $key;

            /** ------------------
             * Auto Increment :
             * ---------------- */
            $i++;
        }
        /** --------------------------------------------------------------------------------
         * End of Loop for Array Prepare Step 2 Decryption.
         * ---------------------------------------------------------------------------------
         * End : Step 2 Decryption.
         * ================================================================================= */

        /** ================================================================================
         * Start : Step 3 Decryption
         * ---------------------------------------------------------------------------------
         * Create Array for Step 2 Decryption :
         * -------------------------------------------------------------
         * Prepare Loop Array for Array Encode char :
         * ------------------------------------------ */
        $reverse = 254;
        $until_loop_reverse = 31;
        $forward = 31;
        $array_for_decryption = array();

        /** ------------------------------------
         * Loop Array for Create Encode char :
         * ----------------------------------- */
        while ($reverse > $until_loop_reverse) {

            /** --------------------------
             * Variable for define number
             * start 33 until 255 :
             * -------------------- */
            $forward = $forward + 1;

            /** ----------------------------------------------------
             * Placing data array "$array_for_decryption" with key
             * From source value of variable "$reverse", then value
             * of array "$array_for_decryption" from source result
             * convert number char to original char :
             * -------------------------------------- */
            $array_for_decryption[$reverse] = chr($forward);

            /** -----------------
             * Auto Decrement :
             * ---------------- */
            $reverse--;
        }
        /** ----------------------------------------
         * End of Loop Array for Create Encode Char.
         * ----------------------------------------- */

        /** -------------------------------------
         * Prepare Loop Array For Encode Char :
         * ------------------------------------ */
        $i = 0;
        $until_loop_encode_char = sizeof($string_step2_decryption);
        $step_3_decryption = '';

        /** -----------------------------
         * Loop Array for Encode Char :
         * ---------------------------- */
        while ($i < $until_loop_encode_char) {

            /** ---------------------------------------------------
             * Define variable "$key_for_access_array" with value
             * from value array "$string_step2_decryption" and key
             * from "Auto Increment" :
             * ----------------------- */
            $key_for_access_array = $string_step2_decryption[$i];

            /** ----------------------------------------------------------------------------
             * Create string for variable "$step_3_decryption with value of variable from
             * value of array "$array_for_decryption" and key array "$array_for_decryption"
             * from value of variable "$key_for_access_array" :
             * ------------------------------------------------ */
            if (isset($array_for_decryption[$key_for_access_array])) {
                $step_3_decryption .= $array_for_decryption[$key_for_access_array];
            } else {
                $step_3_decryption .= '';
            }

            /** -----------------
             * Auto Increment :
             * ---------------- */
            $i++;

        }
        /** ---------------------------------
         * End of Loop Array For Encode Char.
         * ---------------------------------------------------------------------------------
         * End : Step 3 Decryption.
         * ================================================================================= */

        /** ================================================================================
         * Final Decryption :
         * --------------------------------------------------------------------------------- */
//        $final_decryption = base64_decode($step_3_decryption);
        $final_decryption = $step_3_decryption;

        /** ================================================================================
         * Return Final Decryption :
         * --------------------------------------------------------------------------------- */
        return $final_decryption;
//        return $string_step2_decryption;
    }
    /** ------------------------------------------------------------------------------------------------
     * End : Create Function "nkti_dekripsi()"
     * ================================================================================================= */

    /** ================================================================================================
     * Start : Create Function "key_enkrip()" :
     * ----------------------------------------
     * Constructor Function :
     * ----------------------
     * - $time_login = Variable yang berisi TIMESTAMP Login.
     * - $session_key = Variable yang berisi Salt Password.
     * ------------------------------------------------------------------------------------------------- */
    public static function key_enkrip($time_login, $session_key) {

        /** ====================================
         * Define variable for return result :
         * ----------------------------------- */
        $data = '';

        /** =========================================
         * Convert String $salt_passowrd to array :
         * ---------------------------------------- */
        $pre_key = str_split($session_key, 1);

        /** =============================================
         * Prepare Loop to Create Array result encode :
         * -------------------------------------------- */
        $i = 0;
        $until_loop = sizeof($pre_key);
        $first_action = array();

        /** =====================================
         * Loop to Create Array result encode :
         * ------------------------------------ */
        while ($i < $until_loop) {

            /** =========================
             * Convert Chart to ASCII :
             * ------------------------ */
            $first_action[$i] = ord($pre_key[$i]);

            /** -----------------
             * Auto Increment :
             * ---------------- */
            $i++;
        }
        /** -----------------------------------------
         * End of loop to create array result encode.
         * ========================================== */

        /** ================================================
         * Prepare loop to create value of result encode :
         * ----------------------------------------------- */
        $i = 0;
        $until_loop = sizeof($first_action);
        $number = 0;
        $final_action = 0;

        /** ========================================
         * Loop to create value of result encode :
         * --------------------------------------- */
        while ($i < $until_loop) {

            /** =====================================
             * Calculation of value result encode :
             * ------------------------------------ */
            $final_action += $number + $first_action[$i];

            /** -----------------
             * Auto Increment :
             * ---------------- */
            $i++;
        }
        /** --------------------------------------------
         * End of loop to create value of result encode.
         * ============================================= */

        /** ===========================================
         * Calculation result $data and $time_login :
         * ------------------------------------------ */
        $data = $final_action + $time_login;

        /** ================
         * Return Result :
         * --------------- */
        return $data;

    }
    /** ------------------------------------------------------------------------------------------------
     * End : Create Function "key_enkrip()".
     * -------------------------------------------------------------------------------------------------*/
}

echo Encryption::dekripsi($argv[1], $argv[2]);